undefined method `keys' for "5":String when setting associations incorrectly

03/06/2014 11:10 AM - Dominic Cleal

Status: Closed   

Priority: Normal   

Assignee:    

Category: API   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

PUT /api/v2/subnets/1

{"domains":["5"]}

 returns this error:

{"error": {"message":"undefined method `keys' for \"5\":String"}}

 Which is correct, as the correct format is:

{"domains":[{"id":"5"}]}

 But it's not a user-friendly error message.  Better yet would be if it could simply accept this format with IDs or names.

Stack trace:

undefined method `keys' for "5":String (NoMethodError)

/home/dcleal/code/foreman/foreman/app/controllers/api/v2/base_controller.rb:64:in `block (2 levels

) in setup_has_many_params'

/home/dcleal/code/foreman/foreman/app/controllers/api/v2/base_controller.rb:64:in `each'

/home/dcleal/code/foreman/foreman/app/controllers/api/v2/base_controller.rb:64:in `all?'

/home/dcleal/code/foreman/foreman/app/controllers/api/v2/base_controller.rb:64:in `block in setup_

has_many_params'

/home/dcleal/code/foreman/foreman/app/controllers/api/v2/base_controller.rb:60:in `each'

/home/dcleal/code/foreman/foreman/app/controllers/api/v2/base_controller.rb:60:in `setup_has_many_

params'

History

#1 - 03/06/2014 11:12 AM - Dominic Cleal

- Description updated

#2 - 04/30/2021 08:14 AM - Leos Stejskal

- Status changed from New to Closed

I'm closing the issue,

It has been here for some time and I wasn't able to reproduce it on the latest version.

If you think that the issue is still relevant feel free to reopen it.
